"""s_digger.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming digger action.
"""

import pygame
from pygame.locals import *

import globals as g
from excepts import *

attrs = {"isDeathAction": False, "isOnGround": True, "mustStartOnGround": True, "propertyChangeOnly": False }
frames = {1:[[],None]}

subtractMask = pygame.Surface([9,1], SWSURFACE|SRCCOLORKEY)
subtractMask.fill(g.DEFAULT_COLOURKEY)

def update(lemming):
    try:
        if lemming.digCounter >= (lemming.frameCount/2):
            lemming.digCounter = 0
            if not lemming.digStart and (not (lemming.checkPos((lemming.posX,lemming.posY-1), "ground")) or (lemming.checkPos((lemming.posX,lemming.posY-1), "steel"))) :
                lemming.setSkill("s_faller")
            else:
                lemming.digStart = False
                lemming.game.subtract(subtractMask, (lemming.posX - 4, lemming.posY-1) )
                lemming.posY += 1
                lemming._incAnimFrame()
                lemming.digCounter += 1
        else:
            lemming._incAnimFrame()
            lemming.digCounter += 1
    except OutOfThePlayfield:
        lemming.kill()
    return

def set(lemming):
    if lemming.checkPos((lemming.posX, lemming.posY+1), "steel"): 
        raise SkillUnsettable
    else:
        lemming.currentSkill = "s_digger"
        lemming.currentFrame = 0
        lemming.rect.left = frames[1][1].left
        lemming.rect.right = frames[1][1].right
        lemming.rect.width = frames[1][1].width
        lemming.rect.height = frames[1][1].height
        lemming.frameCount = len(frames[1][0])
        lemming.digCounter = lemming.frameCount/2
        lemming.digStart = True
        lemming._incAnimFrame()
        lemming.game.subtract(subtractMask, (lemming.posX - 4, lemming.posY-1) )
        lemming.game.subtract(subtractMask, (lemming.posX - 4, lemming.posY) )
        lemming.posY += 2
    return
