"""s_faller.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming faller action.
"""

from excepts import *

attrs = {"isDeathAction": False, "isOnGround": False, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None]}


def update(lemming):
    try:
        if lemming.isFloater and lemming.altitude >= 12 and lemming.currentSkill == "s_faller":
            lemming.setSkill("s_prefloater")
        elif not(lemming.checkPos((lemming.posX, lemming.posY+1), "ground")):
            if not (lemming.checkPos((lemming.posX, lemming.posY+2), "ground")):
                if not (lemming.checkPos((lemming.posX, lemming.posY+3), "ground")):
                    if (lemming.checkPos((lemming.posX, lemming.posY+4), "ground")):
                        lemming.altitude += 3
                        lemming.posY += 3
                        lemming.setSkill("s_walker")
                    else:
                        lemming.altitude += 3
                        lemming.posY += 3
                        lemming._incAnimFrame()
                else: 
                    lemming.altitude += 2
                    lemming.posY += 2
                    lemming.setSkill("s_walker")
            else: 
                lemming.altitude += 1
                lemming.posY += 1
                lemming.setSkill("s_walker")
        else: # rare case scenario
            lemming.setSkill("s_walker")
       
    except OutOfThePlayfield:
        lemming.kill()    

    try:
        if (lemming.checkPos((lemming.posX, lemming.posY+4), "exit" )):
            lemming.setSkill("s_leaver")     
    except OutOfThePlayfield:
        pass

    return
    

def set(lemming):
    lemming.currentSkill = "s_faller"
    lemming.currentFrame = 0
    lemming.altitude = 0
    lemming.rect.left = frames[lemming.direction][1].left
    lemming.rect.right = frames[lemming.direction][1].right
    lemming.rect.width = frames[lemming.direction][1].width
    lemming.rect.height = frames[lemming.direction][1].height
    lemming.frameCount = len(frames[lemming.direction][0])
    lemming._incAnimFrame()
    return
